
// ==========================================
//
// F6FBB 09/97 Portage DxNet F5MZN sous LINUX
//
// ==========================================

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <unistd.h>
#include <errno.h>
#include <signal.h>
#include <syslog.h>
#include <ctype.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <sys/wait.h>

#include "dos.h"
#include "define.h"
#include "node.h"
#include "tools.h"
#include "buffers.h"
#include "execute.h"
#include "database.h"
#include "protocol.h"

static int EXECUTE_unix(char *Cmd, char *Out);

/*Cette fonction est utilisee afin de permettre de repondre a un acces remote
  a la base de donnees BuckMaster*/
int EXECUTE_buckMaster(int nUserStream, char * Cmd, char * Args, char * Path, int Remote)
{
	struct stat bufstat;
	int ExitCode;
	char *pwd;
	char buf[512];
	char temp_file[80];
	FILE *fPtr;

	TOOLS_removeNR(Cmd);

	pwd = getcwd(NULL, 256);
	sprintf(buf, "%s/%s%s", pwd, Path, Cmd);
	free(pwd);

	if ((stat(buf, &bufstat) == -1) || 
		(!S_ISREG(bufstat.st_mode)) || 
		((bufstat.st_mode & S_IXUSR) == 0))
	{
		return(-1);
	}

	// The file exists and is executable

	strcat(buf, " ");
	strcat(buf, Args);

	sprintf(temp_file, "tmpf_%02d", nUserStream);

	ExitCode = EXECUTE_unix(buf, temp_file);

	if (ExitCode == 127)
		ExitCode = -1;

	if ((ExitCode >= 0) && (fPtr = fopen(temp_file, "rt")))
	{
		char szServer[16];
    	extern char * DATABASE_pszRemoteDB_FromPC;

		/*Recuperer l'indicatif du serveur*/
    	NODE_getNodeCall(0, 0, szServer);
		
		for(;;)
     	{
			if( ! fgets(buf, 128, fPtr) )
				break;
				
			TOOLS_removeNR (buf);

      		/*Router vers utilisateur local ou remote ?*/
      		if( Remote == DB_LOCAL )
				BUFFERS_printBuff(nUserStream, OUT, "%s\n", buf);
      		else
				PROTOCOL_dbResponse(0, szServer, DATABASE_pszRemoteDB_FromPC,
			    nUserStream, buf);
				
		}/*End FOR*/
		
		fclose (fPtr);
	}

	unlink(temp_file);
	return(ExitCode);
}

int EXECUTE_command(int StreamNum, char *Cmd, char *Args, char *Path)
{
	struct stat bufstat;
	int fd;
	int nb;
	int ExitCode;
	char *pwd;
	char buf[512];
	char temp_file[80];

	TOOLS_removeNR(Cmd);

	pwd = getcwd(NULL, 256);
	sprintf(buf, "%s/%s%s", pwd, Path, Cmd);
	free(pwd);

	if ((stat(buf, &bufstat) == -1) || 
		(!S_ISREG(bufstat.st_mode)) || 
		((bufstat.st_mode & S_IXUSR) == 0))
	{
		return(-1);
	}

	// The file exists and is executable

	strcat(buf, " ");
	strcat(buf, Args);

	sprintf(temp_file, "tmpf_%02d", StreamNum);

	ExitCode = EXECUTE_unix(buf, temp_file);

	if (ExitCode == 127)
		ExitCode = -1;

	if ((ExitCode >= 0) && (fd = open(temp_file, O_RDONLY)))
	{
		for (;;)
		{
			nb = read(fd, buf, 250);
			if (nb <= 0)
				break;
			BUFFERS_addBuff_sized(StreamNum, buf, OUT, nb);
		}
		close(fd);
	}

	unlink(temp_file);

	return(ExitCode);
}

/* This function is straight from *NOS */

/*static*/ char *parse_string(char *str)
{
	char *cp = str;
	unsigned long num;

	while (*str != '\0' && *str != '\"') {
		if (*str == '\\') {
			str++;
			switch (*str++) {
			case 'n':
				*cp++ = '\n';
				break;
			case 't':
				*cp++ = '\t';
				break;
			case 'v':
				*cp++ = '\v';
				break;
			case 'b':
				*cp++ = '\b';
				break;
			case 'r':
				*cp++ = '\r';
				break;
			case 'f':
				*cp++ = '\f';
				break;
			case 'a':
				*cp++ = '\007';
				break;
			case '\\':
				*cp++ = '\\';
				break;
			case '\"':
				*cp++ = '\"';
				break;
			case 'x':
				num = strtoul(--str, &str, 16);
				*cp++ = (char) num;
				break;
			case '0':
			case '1':
			case '2':
			case '3':
			case '4':
			case '5':
			case '6':
			case '7':
				num = strtoul(--str, &str, 8);
				*cp++ = (char) num;
				break;
			case '\0':
				return NULL;
			default:
				*cp++ = *(str - 1);
				break;
			};
		} else {
			*cp++ = *str++;
		}
	}
	if (*str == '\"')
		str++;		/* skip final quote */
	*cp = '\0';		/* terminate string */
	return str;
}

static int parse_args(char **argv, char *cmd)
{
	int ct = 0;
	int quoted;

	while (ct < 31)
	{
		quoted = 0;
		while (*cmd && isspace(*cmd))
			cmd++;
		if (*cmd == 0)
			break;
		if (*cmd == '"') {
			quoted++;
			cmd++;
		}
		argv[ct++] = cmd;
		if (quoted) {
			if ((cmd = parse_string(cmd)) == NULL)
				return 0;
		} else {
			while (*cmd && !isspace(*cmd))
				cmd++;
		}
		if (*cmd)
			*cmd++ = 0;
	}
	argv[ct] = NULL;
	return ct;
}

static int EXECUTE_unix(char *Cmd, char *Out)
{
	int pid;
	int status;

	pid = fork();
	if (pid == -1) {
		/* fork error */
		perror("EXECUTE_unix : fork");
		return 0;
	}
	if (pid == 0) 
	{
		int fd;
		char *argv[32];

		parse_args(argv, Cmd);

		if (strstr(argv[0], ".."))
			exit(-1);

		fd = open(Out, O_WRONLY|O_CREAT, S_IRUSR|S_IWUSR);
		if (fd < 0)
			exit(1);
		dup2(fd, STDOUT_FILENO);
		close(fd);

		execvp(argv[0], argv);
		perror("EXECUTE_unix : execvp");
		exit(1);
	}

	/* parent */
	waitpid(pid, &status, 0);

	return (WIFEXITED(status)) ? WEXITSTATUS(status) : -1;
}
